千家信息网

C语言动态规划多种背包问题怎么解决

发表于:2026-11-02 作者:千家信息网编辑
千家信息网最后更新 2026年11月02日,这篇文章主要介绍了C语言动态规划多种背包问题怎么解决的相关知识,内容详细易懂,操作简单快捷,具有一定借鉴价值,相信大家阅读完这篇C语言动态规划多种背包问题怎么解决文章都会有所收获,下面我们一起来看看吧
千家信息网最后更新 2026年11月02日C语言动态规划多种背包问题怎么解决

这篇文章主要介绍了C语言动态规划多种背包问题怎么解决的相关知识,内容详细易懂,操作简单快捷,具有一定借鉴价值,相信大家阅读完这篇C语言动态规划多种背包问题怎么解决文章都会有所收获,下面我们一起来看看吧。

01背包问题

C语言数学问题与简单DP01背包问题详解

先回忆一下这个图

在这我再将01背包问题代码发一遍,可以用来做对比。

二维:

#includeusing namespace std;const int MAXN = 1005;int v[MAXN];    // 体积int w[MAXN];    // 价值 int f[MAXN][MAXN];  // f[i][j], j体积下前i个物品的最大价值 int main() {    int n, m;       cin >> n >> m;    for(int i = 1; i <= n; i++)         cin >> v[i] >> w[i];    for(int i = 1; i <= n; i++)         for(int j = 1; j <= m; j++)        {            //  当前背包容量装不进第i个物品,则价值等于前i-1个物品            if(j < v[i])                 f[i][j] = f[i - 1][j];            // 能装,需进行决策是否选择第i个物品            else                    f[i][j] = max(f[i - 1][j], f[i - 1][j - v[i]] + w[i]);        }               cout << f[n][m] << endl;    return 0;}

一维:

#includeusing namespace std;const int MAXN = 1005;int f[MAXN];  // int main() {    int n, m;       cin >> n >> m;    for(int i = 1; i <= n; i++) {        int v, w;        cin >> v >> w;      // 边输入边处理        for(int j = m; j >= v; j--)            f[j] = max(f[j], f[j - v] + w);    }    cout << f[m] << endl;    return 0;}

完全背包问题

完全背包问题和01背包问题的区别就在于完全背包问题中每件物品都有无限件可用。我们也可以先来试一下暴力写法。

#includeusing namespace std;const int N = 1010;int n, m;int dp[N][N], v[N], w[N];int main(){    cin >> n >> m;    for(int i = 1; i <= n; i ++ )        cin >> v[i] >> w[i];    for(int i = 1; i <= n; i ++ )        for(int j = 0; j <= m; j ++ )            for(int k = 0; k * v[i] <= j; k ++ )//因为每一件物品都有无限件可用,我们只需要找出单件价值最高的商品就可以了                dp[i][j] = max(dp[i][j], dp[i - 1][j - k * v[i]] + k * w[i]);    cout << dp[n][m] << endl;}

优化思路:

我们列举一下更新次序的内部关系:

f[i , j ] = max( f[i-1,j] , f[i-1,j-v]+w , f[i-1,j-2v]+2w , f[i-1,j-3v]+3w , …)

f[i , j-v]= max( f[i-1,j-v] , f[i-1,j-2v] + w , f[i-1,j-3v]+2*w , …)

由上两式,可得出如下递推关系:

f[i][j]=max(f[i,j-v]+w , f[i-1][j])

有了上面的关系,那么其实k循环可以不要了,核心代码优化成这样:

for(int i = 1 ; i <=n ;i++)for(int j = 0 ; j <=m ;j++){    f[i][j] = f[i-1][j];    if(j-v[i]>=0)        f[i][j]=max(f[i][j],f[i][j-v[i]]+w[i]);}

这个代码和01背包的非优化写法很像啊!!!我们对比一下,下面是01背包的核心代码

for(int i = 1 ; i <= n ; i++)for(int j = 0 ; j <= m ; j ++){    f[i][j] = f[i-1][j];    if(j-v[i]>=0)        f[i][j] = max(f[i][j],f[i-1][j-v[i]]+w[i]);}

两个代码其实只有一句不同(注意下标)

f[i][j] = max(f[i][j],f[i-1][j-v[i]]+w[i]);//01背包

f[i][j] = max(f[i][j],f[i][j-v[i]]+w[i]);//完全背包问题

因为和01背包代码很相像,我们很容易想到进一步优化。核心代码可以改成下面这样

for(int i = 1 ; i<=n ;i++)    for(int j = v[i] ; j<=m ;j++)//注意了,这里的j是从小到大枚举,和01背包不一样    {            f[j] = max(f[j],f[j-v[i]]+w[i]);    }

综上所述,完全背包的最终写法如下:

#includeusing namespace std;const int N = 1010;int f[N];int v[N],w[N];int main(){    int n,m;    cin>>n>>m;    for(int i = 1 ; i <= n ;i ++)    {        cin>>v[i]>>w[i];    }    for(int i = 1 ; i<=n ;i++)    for(int j = v[i] ; j<=m ;j++)    {            f[j] = max(f[j],f[j-v[i]]+w[i]);    }    cout<

多重背包问题 I

我们先来看这多重背包问题和01背包问题是不是很像,将s×v,s×w是不是就可以看成01背包问题了?

for(ll i=1;i<=n;i++)    {        cin>>a>>b>>c;        for(ll j=1;j<=c;j++)        {            v[cnt]=a;            w[cnt]=b;            cnt++;        }//将多重背包一个一个拆出来    }

然后转换成01背包问题解决。

#include using namespace std;typedef long long ll;const ll N=1e5+100;ll v[N],w[N];ll f[N];int main(){    ll n,m;    ll cnt=1;    cin>>n>>m;    ll a,b,c;    for(ll i=1;i<=n;i++)    {        cin>>a>>b>>c;        for(ll j=1;j<=c;j++)        {            v[cnt]=a;            w[cnt]=b;            cnt++;        }//将多重背包一个一个拆出来    }    for(ll i=1;i<=cnt;i++)    {        for(ll j=m;j>=v[i];j--)        {            f[j]=max(f[j],f[j-v[i]]+w[i]);        }    }//01背包    cout<

多重背包问题 II

这道题和1看起来没什么区别,但是数据范围变了,数据范围变了如果不优化就话超时,那怎么优化呢?

我们只需要将转换成01背包问题那一部分优化了就可以了。

int cnt = 0;     // 将物品重新分组后的顺序    for (int i = 1; i <= n; i ++)    {        int a, b, s;    // a 体积, b 价值, s 每种物品的个数        scanf("%d %d %d", &a, &b, &s);        int k = 1;   // 二进制拆分 打包时每组中有 k 个同种物品        while (k <= s)  // 即y总说的: 最后一组的物品个数 < 2^(n+1)   1 2 4 8 16 ... 2^n 2^(n+1)        {            cnt ++;            v[cnt] = a * k;  // 每组的体积            w[cnt] = b * k;  // 每组的价值            s -= k;            k *= 2;  // 注意是 k * 2,每次增长一倍,不是k * k        }        if (s > 0)   // 二进制拆分完之后 剩下的物品个数分为新的一组        {            cnt ++;            v[cnt] = a * s;            w[cnt] = b * s;        }    }

为什么可以这样优化呢

我们知道任何一个数都可以转化成二进制的数,那二进制和十进制的区别在哪呢?

一 、二进制与十进制

  • 普通遍历问题

遍历 n 个物品, 采用二进制计数方法遍历与采用十进制技术方法遍历的时间复杂度是一样的

举例来说, 对于十进制数 8

十进制遍历: 0,1,2,3,4,5,6,7 共 8 次遍历

二进制遍历: 000, 001, 010, 011, 100, 101, 110, 111 共 8 次遍历

  • 多重背包问题

同样的道理, 对于多重背包问题, 采用二进制的遍历方法不能优化时间复杂度

优化的原因在于引入了动态规划

二 、动态规划的时间复杂度估算

动态规划的时间复杂度 ≈≈ 问题的总个数 × 问题要做出的选择数

如, 对于 01 背包问题, 问题的总个数为N⋅V (N 为物品个数, V 为背包容量), 问题要做出的选择数为 2(选或不选)

则 01 背包问题的时间复杂度约为 2N⋅V

三 、多重背包

如果不采用动态规划的做法, 就像普通的遍历问题那样, 是否采用二进制的计数方法对时间复杂度的优化没有任何关系

但采用二进制的计数方法会影响问题的总个数与问题的选择数的乘积, 即动态规划做法下多重背包的时间复杂度

多重背包的动态规划时间复杂度

十进制遍历方法

问题的总个数为 N⋅V, N 为物品的种类数, V 为背包容量

问题的选择数约为 Smax,Smax 为每种物品数量的最大值

十进制下多重背包问题的 DP 时间复杂度为: N⋅V⋅Smax

二进制遍历方法

十进制下, 一种物品有 si个, 二进制下, 变为 1, 2, … , lgsi 个物品, 则共有 lgs1+lgs2+…+lg⁡sn 个物品, 约为 Nlgsmax 个物品

问题的总个数为 N⋅V⋅lgsmax

问题的选择数为 2

十进制下多重背包问题的 DP 时间复杂度为: 2N⋅V⋅lgsmax

最后请看代码

#include using namespace std;const int N = 11 * 1000 + 10, M = 2010;int v[N], w[N];int f[M];int main(){    int  n, m;    scanf("%d %d", &n, &m);    int cnt = 0;     // 将物品重新分组后的顺序    for (int i = 1; i <= n; i ++)    {        int a, b, s;    // a 体积, b 价值, s 每种物品的个数        scanf("%d %d %d", &a, &b, &s);        int k = 1;   // 二进制拆分 打包时每组中有 k 个同种物品        while (k <= s)  // 即y总说的: 最后一组的物品个数 < 2^(n+1)   1 2 4 8 16 ... 2^n 2^(n+1)        {            cnt ++;            v[cnt] = a * k;  // 每组的体积            w[cnt] = b * k;  // 每组的价值            s -= k;            k *= 2;  // 注意是 k * 2,每次增长一倍,不是k * k        }        if (s > 0)   // 二进制拆分完之后 剩下的物品个数分为新的一组        {            cnt ++;            v[cnt] = a * s;            w[cnt] = b * s;        }    }    n = cnt;  // 所有的组数即为 01背包中的物品个数    // 写01背包模板    for (int i = 1; i <= n; i ++)        for (int j = m; j >= v[i]; j --)            f[j] = max(f[j], f[j - v[i]] + w[i]);    printf("%d", f[m]);    return 0;}

分组背包问题

  • 状态表示:f[i][j]

集合:从前i组物品中选,且总体积不超过j的所有方案的集合.

属性:最大值

  • 状态计算:

思想-----集合的划分

集合划分依据:根据从第i组物品中选哪个物品进行划分.

f[i][j] = max(f[i][j], f[i - 1][j - v[i][k]] + w[i][k]);

请看代码

#includeusing namespace std;const int N=110;int f[N][N];  //只从前i组物品中选,当前体积小于等于j的最大值int v[N][N],w[N][N],s[N];   //v为体积,w为价值,s代表第i组物品的个数int n,m,k;int main(){    cin>>n>>m;    for(int i=1;i<=n;i++){        cin>>s[i];        for(int j=0;j>v[i][j]>>w[i][j];  //读入        }    }    for(int i=1;i<=n;i++){        for(int j=0;j<=m;j++){            f[i][j]=f[i-1][j];  //不选 不选表示不选第 i 组物品的所有物品,只从前 i−1 组物品里面选            for(int k=0;k=v[i][k])     f[i][j]=max(f[i][j],f[i-1][j-v[i][k]]+w[i][k]);              }        }    }    cout<

因为只用到了第i-1列,所以可以仿照01背包的套路逆向枚举体积

#includeusing namespace std;const int N=110;int f[N];int v[N][N],w[N][N],s[N];int n,m,k;int main(){    cin>>n>>m;    for(int i=0;i>s[i];        for(int j=0;j>v[i][j]>>w[i][j];        }    }    for(int i=0;i=0;j--){            for(int k=0;k=1;k--)也可以                if(j>=v[i][k])     f[j]=max(f[j],f[j-v[i][k]]+w[i][k]);              }        }    }    cout<

关于"C语言动态规划多种背包问题怎么解决"这篇文章的内容就介绍到这里,感谢各位的阅读!相信大家对"C语言动态规划多种背包问题怎么解决"知识都有一定的了解,大家如果还想学习更多知识,欢迎关注行业资讯频道。

背包 问题 物品 个数 二进制 动态 规划 复杂 复杂度 时间 代码 十进制 十进 价值 体积 方法 选择 语言 多种 最大 数据库的安全要保护哪些东西 数据库安全各自的含义是什么 生产安全数据库录入 数据库的安全性及管理 数据库安全策略包含哪些 海淀数据库安全审计系统 建立农村房屋安全信息数据库 易用的数据库客户端支持安全管理 连接数据库失败ssl安全错误 数据库的锁怎样保障安全 手冲咖啡和咖啡机区别 互联网黑科技 互联网科技卖菜 互联网巨头科技公司 银优互联网科技有限公司 一五八零互联网科技 华脉科技工业互联网产品 互联网和高科技公司 互联网科技教育视频 南平创想时代互联网科技有限公司 玉溪互联网科技怎么选 速维有品互联网信息科技(苏州)有限公司 米聚互联网科技南京有限公司排面 烟台灵鸽互联网科技有限公司 云南省自由互联网科技有限公司 中天科技中国工业互联网 江苏互联网智能科技软件 昆明中奇联合互联网科技 全球科技与互联网公司市值变化 黑龙江互联网科技公司 精品咖啡豆 广州百单互联网科技有限公司 互联网下的科技发展 互联网科技集团 互联网科技的英文 深圳艾佳互联网科技 花神(南京)互联网科技有限公司 广州千川互联网科技有限公司 陕西云淼互联网科技公司 广州有谷有贝互联网科技有限公司
0